---
title: CanvasPattern.setTransform()
slug: Web/API/CanvasPattern/setTransform
tags:
  - API
  - Canvas
  - CanvasPattern
  - Experimental
  - Method
  - Reference
---
<div>{{APIRef("Canvas API")}}</div>

<p>The <code><strong>CanvasPattern</strong></code><strong><code>.setTransform()</code></strong> method uses an {{domxref("SVGMatrix")}} or {{domxref("DOMMatrix")}} object as the pattern's transformation matrix and invokes it on the pattern.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <em>pattern</em>.setTransform(<em>matrix</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>matrix</code></dt>
 <dd>An {{domxref("SVGMatrix")}} or {{domxref("DOMMatrix")}} to use as the pattern's transformation matrix.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_setTransform_method">Using the <code>setTransform</code> method</h3>

<p>This is just a simple code snippet which uses the <code>setTransform</code> method to create a {{domxref("CanvasPattern")}} with the specified pattern transformation from an {{domxref("SVGMatrix")}}. The pattern gets applied if you set it as the current {{domxref("CanvasRenderingContext2D.fillStyle", "fillStyle")}} and gets drawn onto the canvas when using the {{domxref("CanvasRenderingContext2D.fillRect", "fillRect()")}} method, for example.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
&lt;svg id="svg1"&gt;&lt;/svg&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[12] notranslate">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

var svg1 = document.getElementById('svg1');
var matrix = svg1.createSVGMatrix();

var img = new Image();
img.src = 'https://mdn.mozillademos.org/files/222/Canvas_createpattern.png';

img.onload = function() {
  var pattern = ctx.createPattern(img, 'repeat');
  pattern.setTransform(matrix.rotate(-45).scale(1.5));
  ctx.fillStyle = pattern;
  ctx.fillRect(0, 0, 400, 400);
};
</pre>

<p>Note that newer browser versions started to support {{domxref("DOMMatrix")}} as an input to <code>setTransform()</code>, so for example you could replace the <code>SVGMatrix</code> in the above example with the following:</p>

<pre class="brush: js notranslate">const matrix = new DOMMatrix([1, .2, .8, 1, 0, 0]);</pre>

<p>Edit the code below and see your changes update live in the canvas:</p>

<div class="hidden">
<h6 id="Playable_code">Playable code</h6>

<pre class="brush: html notranslate">&lt;canvas id="canvas" width="400" height="200" class="playable-canvas"&gt;&lt;/canvas&gt;
&lt;svg id="svg1" style="display:none"&gt;&lt;/svg&gt;
&lt;div class="playable-buttons"&gt;
  &lt;input id="edit" type="button" value="Edit" /&gt;
  &lt;input id="reset" type="button" value="Reset" /&gt;
&lt;/div&gt;
&lt;textarea id="code" class="playable-code" style="height:120px"&gt;
var img = new Image();
img.src = 'https://mdn.mozillademos.org/files/222/Canvas_createpattern.png';
img.onload = function() {
  var pattern = ctx.createPattern(img, 'repeat');
  pattern.setTransform(matrix.rotate(-45).scale(1.5));
  ctx.fillStyle = pattern;
  ctx.fillRect(0, 0, 400, 400);
};&lt;/textarea&gt;
</pre>

<pre class="brush: js notranslate">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');
var textarea = document.getElementById('code');
var reset = document.getElementById('reset');
var edit = document.getElementById('edit');
var code = textarea.value;

var svg1 = document.getElementById('svg1');
var matrix = svg1.createSVGMatrix();

function drawCanvas() {
  ctx.clearRect(0, 0, canvas.width, canvas.height);
  eval(textarea.value);
}

reset.addEventListener('click', function() {
  textarea.value = code;
  drawCanvas();
});

edit.addEventListener('click', function() {
  textarea.focus();
})

textarea.addEventListener('input', drawCanvas);
window.addEventListener('load', drawCanvas);
</pre>
</div>

<p>{{ EmbedLiveSample('Playable_code', 700, 380) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-canvaspattern-settransform", "CanvasPattern.setTransform")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasPattern.setTransform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasPattern")}}</li>
 <li>{{domxref("SVGMatrix")}}</li>
 <li>{{domxref("DOMMatrix")}}</li>
</ul>
